


#include "STM32F4xx.h"

#define MASK(x) (1UL << (x))

void Delay (uint32_t nCount)
{
	while(nCount--)
	{
			__NOP();
	}
}

/*------------------------------------------------------------------------------
	Example for initialising an external speaker
	Connect the speaker (with a cpacitor and optional resistor) to port D pin 2
	and the GND
	*------------------------------------------------------------------------------*/
void Init_Speaker(void){

		//Enable clock to port A
		RCC->AHB1ENR|=RCC_AHB1ENR_GPIODEN;
	
		GPIOD->MODER|=GPIO_MODER_MODER2_0;
	
}

/*------------------------------------------------------------------------------
	Example for initialising the three way switches
	*------------------------------------------------------------------------------*/
void Init_Switch(void){

	//Enable clock to port A
	RCC->AHB1ENR|=RCC_AHB1ENR_GPIOAEN;

	
	//Pull-up the output
	GPIOA->PUPDR|=GPIO_PUPDR_PUPDR1_0; 
	GPIOA->PUPDR|=GPIO_PUPDR_PUPDR3_0;
	GPIOA->PUPDR|=GPIO_PUPDR_PUPDR5_0;
	
}

/*------------------------------------------------------------------------------
	Making various sounds depending on the frequency
	*------------------------------------------------------------------------------*/

void Speaker_Beep(uint32_t frequency){
	
	if(frequency!=0){
	
	GPIOD->BSRRL=(MASK(2));
	Delay(frequency);
	GPIOD->BSRRH=(MASK(2));
	Delay(frequency);
	}

}




int main(void)
{
	uint32_t frequency =20000;

	
	Init_Speaker();
	while(1){
	
	if(!(GPIOA->IDR&(MASK(1)))){
			frequency++;
	}
	else if(!(GPIOA->IDR&(MASK(3)))){
			if(frequency>1000){
			frequency--;
			}
	}
	else if(!(GPIOA->IDR&(MASK(5)))){
	}
	else{
			frequency=0;
	}		
  
	Speaker_Beep(frequency);
	}
}




// *******************************ARM University Program Copyright  ARM Ltd 2013*************************************  
